

#pragma once

#include "CoreMinimal.h"
#include "ClothNode.h"
#include "ClothSimulationComponent.generated.h"


UCLASS( ClassGroup=(Custom), meta=(BlueprintSpawnableComponent) )
class CV5_LATKA_API UClothSimulationComponent : public USceneComponent
{
	GENERATED_BODY()

public:	
	// Sets default values for this component's properties
	UClothSimulationComponent();

	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category="Simulation parameters")
	float NodeMass = 0.1f;

	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category="Simulation parameters")
	float StructuralElasticity = 1.0f;

	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category="Simulation parameters")
	float ShearElasticity = 1.0f;

	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category="Simulation parameters")
	float FlexionElasticity = 1.0f;

	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category="Simulation parameters")
	float Damping = 1.0f;

	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category="Simulation parameters")
	float TimeDilation = 1.0f;

	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category="Simulation parameters")
	float Scale = 100.0f;

	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category="Simulation parameters")
	int32 GridSize = 10;

	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category="Display and interaction")
	TSubclassOf<AActor> CollisionActor;

protected:
	// Called when the game starts
	virtual void BeginPlay() override;

	TArray<FClothNodeRef> ClothNodes;
	TArray<FClothSpringRef> ClothSprings;

public:	
	// Called every frame
	virtual void TickComponent(float DeltaTime, ELevelTick TickType, FActorComponentTickFunction* ThisTickFunction) override;
	bool HasValidParameters();
	void GenerateCloth();

	FVector3f GetNodePosition(int32 NodeIndex) const;
};
